
def myprint1(arg1):
    print(arg1)

def myprint1a(arg1, arg2):
    print(arg1, arg2)

# myprint1("hello", "there") # error, because myprint1 wants exactly 1 argument
# myprint1a("hello") # error, because myprint1a wants exactly 2 arguments


def myprint2(*arg):
    print(arg[0], arg[1])

# myprint2("hello")
myprint2("hello", "there")       # arg = ["hello", "there"]
# myprint2()                       # arg = []
myprint2("hi", "there", "you")   # arg = ["hi", "there", "you"]


def myprint3(*arg):
    # print between zero and many things
    for i in range(len(arg)):
        print(arg[i])

def myprint3(m1, m2, *arg): # mandatory comes before optional
    # print between two and many things
    print(m1)
    print(m2)
    for i in range(len(arg)):
        print(arg[i])

def myprint3b(m1, m2, *arg): # mandatory comes before optional
    # print between two and many things
    print(f"{m1} {m2} {" ".join(arg)}")

def myprint4(m1="hello", *arg): # mandatory comes before optional
    # print between one and many things
    print(f"{m1} {" ".join(arg)}")

myprint4()


def mykwprint(m1="word1", m2="word2"):
    print(m1, m2)

mykwprint("hello", "there")
mykwprint(m2="there", m1="hello")

def myoptionalkwprint(**kwargs):
    for k in kwargs:
        print(k, kwargs[k])

myoptionalkwprint(name="Joe", location="the desert", temperament="terrified")

## output:
# name Joe
# location the desert
# temperament terrified





