

class Shape:
  def __init__(self, size=0, color="black"):
    self._size = size
    self._color = color

  # alternate version
  def __init__(self, **args, *positionalargs):
    # args is a dictionary
    # positionalargs is a list
    self._size = args["size"]
    self._color = args["color"]
    self._extra = positionalargs


  def get_size(self):
    return self._size

  def get_color(self):
    return self._color

  def set_size(self, size):
    if float(size) >= 0:
      self._size = size
    else:
      raise ValueError("Size must be a number greater than or equal to zero")

  def set_color(self, color):
    self._color = str(color)


myshape = Shape(size=3, color="black")

myshape = Shape(size=-3, color=99) # should really generate an error

