#include <stdio.h>
// example solution

int main(){

    int arr[4] = {10, 20, 30, 40};
    int tmp;

    // simple swap of values (not what was asked for):
    /*
    tmp = arr[0];
    arr[0] = arr[3];
    arr[3] = tmp;
    */

    printf("Before swap:\n%d %d %d %d\n", arr[0], arr[1], arr[2], arr[3]);

    int *ptr_first;         // ptr_first is a pointer to int
    int *ptr_last;          // ptr_first is a pointer to int
    ptr_first = arr;        // copy the value of arr to ptr_first
    ptr_last = arr+3;

    tmp = *ptr_first;       // dereference ptr_first, to access value
    *ptr_first = *ptr_last; // copy values over
    *ptr_last = tmp;

    // now print out the list swapped again
    printf("After swap:\n%d %d %d %d\n", arr[0], arr[1], arr[2], arr[3]);

    // works the other way around too - a pointer can be treated like an array
    int* intp;
    intp = arr;
    tmp = intp[1];
    return 0;
}

// to swap a and b always requires tmp


