
# Session Notes

* [Session 1](session1.md)
* [Session 2](session2.md)
* [Session 3](session3.md)
* [Session 4](session4.md)
* [Session 4 supplement](session4b.md)
* [Session 5](session5.md)
* [Session 6](session6.md)

# Setup Development Environment

* [Set up local environment](guides/localenvironment.md)


## Git scenarios and how to solve them:

* [linux/unix/osx version](guides/scenarios_unix.md) **Most applicable to syzygy**
* [git bash version](guides/scenarios_gitbash.md)
* [git cmd version](guides/scenarios_gitcmd.md)

## Good practices

* [Basic git workflow advice](guides/gitworkflowguidance.md)

## Code Examples

* [In-class examples](examples)
