# Midterm review

1. 90% of midterm is based on assignments.
2. remainder may involve material in the notes / examples.
3. there will be no multiple choice or memorization questions
4. primary focus is on practical and reflective tasks (about your work)
5. exam takes during the time of regular class in the mode of the class.
6. you are allowed to consult reference material but you must complete the exam independently, without assistance. Any sources other than the notes must be cited (ie, if you looked up stackexchange for something, give a stable link to the answer that you looked at. worst case, a straight copy might not get credit, but at least you will not have an academic misconduct concern).
7. the exam assumes you will be using ufv.syzygy.ca or jupyter.work but if you are able to accomplish the tasks using your local machine, this is permitted (that said, sc-gitlab.uvf.ca is mandatory)
8. the exam is submitted via sc-gitlab.ufv.ca the same way our assignments have been done (multiple commits, possibly required at specific checkpoints in the exam, and/or at specific times)

# My exam construction process:
1. collect all assignments
2. create tasks that depend only on knowledge in those assignments
3. as much as possible align the type of task with what you have already done (with the except of explaining rationale for your assignment choices)
4. permit a small amount of material from notes / examples that are not int he assignments, but aim for no more than 10% of this.

## Highlights from assignments:

### Assignment 1

    - basic ssh authentication setup
    - creating repository
    - writing hello world
    - commit, and push to remote repository
    - create basic function with multiple parameters
    - minor for loop (could use while loop)

### Assignment 2

    - Class definition including methods and private attributes
    - default values when initializing new class
    - getters and setters
    - utility functions (ie, permiter, area calculations)
    - input validation, raising ValueError

### Assignment 3

    - use a context manager to handle file operations (with open,...)
    - managing data in an object (ie, a dictionary vs a class with attributes)
    - serializing and deserializing classes
    - using json to save and load an instance of a class
    - create a functional console menu for your application


### Assignment 4

    - In c, use pointers to swap the values in two different variables or locations in an array.
    - in c, use printf to output values in pointers and/or variables.
    - use the dereference operator (*) to dereference pointers


    




